package com.sobot.common.utils;

import android.content.Context;

import com.sobot.utils.SobotStringUtils;

import java.util.HashMap;
import java.util.Map;

/**
 * 下载的String 资源
 */

public class SobotStringResource {
    public static Map<String,String> map = new HashMap<>();
    public static String SOBOT_LANGUAGE_VERSION="sobot_language_version_";
    public static String SOBOT_LANGUAGE_CODE="sobot_language_code_";

    public static String getString(String str) {
        if(map==null || map.isEmpty()){
            return "";
        }
        String strValue = map.get(str);
        if(SobotStringUtils.isEmpty(strValue)){
            strValue = "";
        }
        return strValue;
    }
    public static String getString(Context context,String str) {
        String strValue = map.get(str);
        if(SobotStringUtils.isEmpty(strValue)){
            strValue = context.getResources().getString(getIdByName(context,str));
        }
        return strValue;
    }
    public static int getIdByName(Context context, String resName) {
        context = context.getApplicationContext();
        String packageName = context.getPackageName();
        int indentify = context.getResources().getIdentifier(resName,
                "string", packageName);
        return indentify;
    }
    public static void setMap(Map<String, String> map) {
        SobotStringResource.map = map;
    }

}
